Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 541)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 542)
@@ -76,21 +76,21 @@
 
 	/** The currentpartid. */
 	protected int currentpartid = 0;
-
+	
 	/** The current Fmax value. */
 	protected int Fmax = 0;
 	/** The current Fmin value. */
 	protected int Fmin = 9999999;
-
 	/** The lexicon used to compute the index (if query = null || query == [] && properties.size() == 1 */
 	protected Lexicon lexicon;
+	boolean lexiconMode = false;
 	/** The current lines. */
 	protected List<Line> lines = new ArrayList<Line>();
 	/** The current number of lines. */
-	protected int nLines = 0;
+	protected int nTotalTokens = 0;
+
 	/** The partnames. The corpus name if built with a Corpus or the parts names if built with a Partition */
 	protected List<String> partnames = new ArrayList<String>();
-
 	/** The fmax filter value parameter. */
 	protected Integer pFmaxFilter = null;
 	/** The fmin filter value parameter. */
@@ -101,47 +101,20 @@
 	protected List<Property> pProperties;
 	/** The string used to separated property values. */
 	protected String pPropertiesSeparator = "_"; // the separator of properties values //$NON-NLS-1$
+	private String pPropertySeparator = "_";
+
 	/** The CQP query. */
 	protected Query pQuery;
+
+	private Integer pTopIndex;
+
 	/** The vmax filter value parameter. */
 	protected Integer pVmaxFilter = null;
-
+	
 	/** The writer. */
 	private BufferedWriter writer;
 
 	/**
-	 * compute a index, given a corpus, a query and analysis properties.
-	 *
-	 * @param corpus the corpus
-	 * @throws CqiClientException 
-	 * @throws CqiServerError 
-	 * @throws IOException 
-	 */
-	public Index(Corpus corpus) {
-		super(corpus);
-	}
-
-	/**
-	 * Compute an index per Part of the partition.
-	 *
-	 * @param partition the partition
-	 * @throws CqiClientException 
-	 * @throws CqiServerError 
-	 * @throws IOException 
-	 */
-	public Index(Partition partition) {
-		super(partition);
-	}
-	
-	boolean lexiconMode = false;
-	public void setLexiconMode(boolean mode) {
-		this.lexiconMode = mode;
-	}
-	public boolean getLexiconMode() {
-		return this.lexiconMode;
-	}
-	
-	/**
 	 * Create a CQL query using an Index lines
 	 *
 	 * @param selection the selection
@@ -180,51 +153,31 @@
 		query = query.substring(0, query.length() - 1);
 		return query;
 	}
+
+	/**
+	 * compute a index, given a corpus, a query and analysis properties.
+	 *
+	 * @param corpus the corpus
+	 * @throws CqiClientException 
+	 * @throws CqiServerError 
+	 * @throws IOException 
+	 */
+	public Index(Corpus corpus) {
+		super(corpus);
+	}
 	
 	/**
-	 * This method alter the index first column frequencies using a table stored in the R workspace
-	 * 
-	 * @param referenceCorpus the R table variable name
-	 * @return true if frequencies have been altered
-	 * 
-	 * @throws RWorkspaceException
-	 * @throws REXPMismatchException
+	 * Compute an index per Part of the partition.
+	 *
+	 * @param partition the partition
+	 * @throws CqiClientException 
+	 * @throws CqiServerError 
+	 * @throws IOException 
 	 */
-	public boolean alterFrequencies(String referenceCorpus) throws RWorkspaceException, REXPMismatchException {
-		String[] ref_forms = RWorkspace.getRWorkspaceInstance().eval("rownames("+referenceCorpus+")").asStrings(); //$NON-NLS-1$ //$NON-NLS-2$
-		int[] ref_freqs = RWorkspace.getRWorkspaceInstance().eval(referenceCorpus+"[,1]").asIntegers(); //$NON-NLS-1$
-		if (ref_forms.length != ref_freqs.length) {
-			System.out.println("Cannot alter index frequencies with the '"+referenceCorpus+"' empty table.");
-			return false;
-		}
-		HashMap<String, Integer> ref_counts = new HashMap<String, Integer>();
-		for(int i = 0 ; i < ref_forms.length ; i++) ref_counts.put(ref_forms[i], ref_freqs[i]);
-
-		for (org.txm.index.core.functions.Line l : this.getAllLines()) {
-			String key = l.toString();
-			if (ref_counts.containsKey(key)) {
-				int[] f = {ref_counts.get(key)};
-				l.setCounts(f, 0);
-			}
-		}
-		this.updateFminFmax();
-		return true;
-		//voc.toTxt(new File("/home/mdecorde/TEMP/after.tsv"), "UTF-8", "\t", "");
+	public Index(Partition partition) {
+		super(partition);
 	}
-
 	@Override
-	public void clean() {
-		try {
-			if (writer != null) {
-				this.writer.flush();
-				this.writer.close();
-			}
-		} catch (IOException e) {
-			org.txm.utils.logger.Log.printStackTrace(e);
-		}
-	}
-
-	@Override
 	protected boolean _compute(boolean update) throws Exception {
 		lines.clear();
 		counts.clear();
@@ -270,7 +223,6 @@
 			}
 		}
 
-
 		this.filterLines();
 
 		Log.info("Sorting...");
@@ -279,11 +231,74 @@
 		this.cut();
 
 		this.dirty = false;
-
+		this.pTopIndex = 0;
 		Log.info("Index done.");
 		return true;
 	}
+	
+	/**
+	 * This method alter the index first column frequencies using a table stored in the R workspace
+	 * 
+	 * @param referenceCorpus the R table variable name
+	 * @return true if frequencies have been altered
+	 * 
+	 * @throws RWorkspaceException
+	 * @throws REXPMismatchException
+	 */
+	public boolean alterFrequencies(String referenceCorpus) throws RWorkspaceException, REXPMismatchException {
+		String[] ref_forms = RWorkspace.getRWorkspaceInstance().eval("rownames("+referenceCorpus+")").asStrings(); //$NON-NLS-1$ //$NON-NLS-2$
+		int[] ref_freqs = RWorkspace.getRWorkspaceInstance().eval(referenceCorpus+"[,1]").asIntegers(); //$NON-NLS-1$
+		if (ref_forms.length != ref_freqs.length) {
+			System.out.println("Cannot alter index frequencies with the '"+referenceCorpus+"' empty table.");
+			return false;
+		}
+		HashMap<String, Integer> ref_counts = new HashMap<String, Integer>();
+		for(int i = 0 ; i < ref_forms.length ; i++) ref_counts.put(ref_forms[i], ref_freqs[i]);
 
+		for (org.txm.index.core.functions.Line l : this.getAllLines()) {
+			String key = l.toString();
+			if (ref_counts.containsKey(key)) {
+				int[] f = {ref_counts.get(key)};
+				l.setCounts(f, 0);
+			}
+		}
+		this.updateFminFmax();
+		return true;
+		//voc.toTxt(new File("/home/mdecorde/TEMP/after.tsv"), "UTF-8", "\t", "");
+	}
+	
+	@Override
+	public boolean canCompute() {
+		if (getCorpus() == null && getPartition() == null) {
+			System.out.println("Corpus or partition not set");
+			return false;
+		}
+
+		if (pProperties == null || pProperties.size() == 0) {
+			System.out.println("No property set.");
+			return false;
+		}
+
+		if (pQuery == null || pQuery.getQueryString().length() == 0) {
+			System.out.println("No query set.");
+			return false;
+		}
+		
+		return true;
+	}
+
+	@Override
+	public void clean() {
+		try {
+			if (writer != null) {
+				this.writer.flush();
+				this.writer.close();
+			}
+		} catch (IOException e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+		}
+	}
+
 	/**
 	 * Initializes the index using a lexicon.
 	 *
@@ -304,7 +319,7 @@
 				lexicon.compute(monitor);
 			}
 
-			this.nLines = lexicon.nbrOfToken();
+			this.nTotalTokens = lexicon.nbrOfToken();
 			String[] forms = lexicon.getForms();
 			int[] freqs = lexicon.getFreq();
 			int[] ids = lexicon.getIds();
@@ -355,7 +370,6 @@
 		this.releaseSemaphore();
 	}
 
-
 	/**
 	 * Equals.
 	 *
@@ -373,6 +387,7 @@
 		return false;
 	}
 
+
 	/**
 	 * remove linen which frequency is not in the [Fmin,Fmax] inverval.
 	 *
@@ -391,14 +406,14 @@
 			int f = line.getFrequency();
 			if (pFminFilter != null && f < pFminFilter) { // if its frequency is not in the interval, remove it
 
-				nLines -= line.getFrequency();
+				nTotalTokens -= line.getFrequency();
 				lines.remove(i);
 				i--;
 				continue; // no need to go further the line is removed
 			}
 			if (pFmaxFilter != null && f > pFmaxFilter) { // if its frequency is not in the interval, remove it
 
-				nLines -= line.getFrequency();
+				nTotalTokens -= line.getFrequency();
 				lines.remove(i);
 				i--;
 			}
@@ -510,6 +525,10 @@
 		return lexicon;
 	}
 
+	public boolean getLexiconMode() {
+		return this.lexiconMode;
+	}
+
 	/**
 	 * return the lines from le "start"th one to the "end"th one.
 	 *
@@ -623,6 +642,10 @@
 
 
 
+	public String getPropertySeparator() {
+		return pPropertySeparator ;
+	}
+
 	/**
 	 * Gets the query.
 	 *
@@ -654,14 +677,18 @@
 	}
 
 	/**
-	 * Gets the t.
+	 * Gets the number of tokens found
 	 *
 	 * @return the number of tokens returned by the selection
 	 */
 	public int getT() {
-		return nLines;
+		return nTotalTokens;
 	}
 
+	public int getTopIndex() {
+		return pTopIndex;
+	}
+
 	/**
 	 * Gets the v.
 	 *
@@ -696,7 +723,7 @@
 		QueryResult result = corpus.query(pQuery, "index", true); //$NON-NLS-1$
 		boolean isTargetUsed = CQPEngine.getCqiClient().subCorpusHasField(result.getQualifiedCqpId(), ICqiClient.CQI_CONST_FIELD_TARGET);
 		int nbresults = result.getNMatch();
-		this.nLines += nbresults; // get number of tokens
+		this.nTotalTokens += nbresults; // get number of tokens
 
 		// System.out.println("nLines : "+nLines);
 		List<Match> matches = null;
@@ -814,6 +841,10 @@
 
 	}
 
+	public void setLexiconMode(boolean mode) {
+		this.lexiconMode = mode;
+	}
+
 	/**
 	 * update the lines counts.
 	 */
@@ -829,11 +860,14 @@
 		}
 	}
 
+	public void setNLinesPerPage(int nLinesPerPage) {
+		this.pNLinesPerPage = Math.max(nLinesPerPage, 1);
+	}
+
 	public void setParameters(List<Property> props) {
 		this.pQuery = new Query("[]");
 		this.pProperties = props;
 		this.lexicon = null;
-		this.dirty = true;
 	}
 
 	public void setParameters(Query query, List<Property> props, Integer filterFmin, Integer filterFmax, Integer filterVmax, Integer nLinesPerPage) {
@@ -843,7 +877,6 @@
 		if (filterFmin != null) this.pFminFilter = filterFmin;
 		if (filterVmax != null) this.pVmaxFilter = filterVmax;
 		if (nLinesPerPage != null) this.pNLinesPerPage = nLinesPerPage;
-		this.dirty = true;
 	}
 
 	@Override
@@ -857,7 +890,6 @@
 			Integer nLinesPerPage = (Integer) parameters.get("nLinesPerPage");
 
 			this.setParameters(query, props, filterFmin, filterFmax, filterVmax, nLinesPerPage);
-			this.saveParameters();
 		} catch (Exception e) {
 			System.out.println("Error while setting parameters of Index: "+e.getLocalizedMessage());
 			Log.printStackTrace(e);
@@ -866,6 +898,15 @@
 		return true;
 	}
 
+
+	public void setTopLine(int i) {
+		pTopIndex = Math.max(i, 0);
+	}
+
+	public void setVMax(int maxFilter) {
+		this.pVmaxFilter = maxFilter;
+	}
+
 	/**
 	 * Sort lines.
 	 *
@@ -876,6 +917,7 @@
 		LineComparator lc = new LineComparator(mode, reverse);
 		lc.initialize(this.getCorpus());
 		Collections.sort(lines, lc);
+		this.pTopIndex = 0; // return to the first page
 	}
 
 	/**
@@ -973,7 +1015,6 @@
 		writer.close();
 	}
 
-
 	/**
 	 * Write the lines between from and to on a writer.
 	 *
@@ -1050,30 +1091,4 @@
 				Fmax = f;
 		}
 	}
-
-	@Override
-	public boolean canCompute() {
-		if (getCorpus() == null && getPartition() == null) {
-			System.out.println("Corpus or partition not set");
-			return false;
-		}
-
-		if (pProperties == null || pProperties.size() == 0) {
-			System.out.println("No property set.");
-			return false;
-		}
-
-		if (pQuery == null || pQuery.getQueryString().length() == 0) {
-			System.out.println("No query set.");
-			return false;
-		}
-		
-		return true;
-	}
-
-	@Override
-	public boolean saveParameters() {
-		// TODO Auto-generated method stub
-		return false;
-	}
 }
Index: tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/editor/DiagnosticEditor.java
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/editor/DiagnosticEditor.java	(revision 541)
+++ tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/editor/DiagnosticEditor.java	(revision 542)
@@ -55,7 +55,7 @@
 	}
 	
 	@Override
-	public void refresh() {
+	public void refresh(boolean update) {
 		super.refresh();
 		File file = diag.getHTMLFile();
 		if (file.exists()) {
Index: tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/Messages.java
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/Messages.java	(revision 541)
+++ tmp/org.txm.searchengine.cqp.rcp/src/org/txm/searchengine/cqp/rcp/Messages.java	(revision 542)
@@ -19,6 +19,7 @@
 	public static String CQPPreferencePage_18;
 	
 	static {
+		System.out.println("INIT: "+Messages.class.getPackage().getName());
 		Utf8NLS.initializeMessages(Messages.class);
 	}
 }
Index: tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF	(revision 541)
+++ tmp/org.txm.searchengine.cqp.rcp/META-INF/MANIFEST.MF	(revision 542)
@@ -13,5 +13,6 @@
  org.eclipse.ui
 Export-Package: org.txm.rcp.commands.base,
  org.txm.searchengine.cqp.rcp,
+ org.txm.searchengine.cqp.rcp.command,
  org.txm.searchengine.cqp.rcp.editor,
  org.txm.searchengine.cqp.rcp.preferences
Index: tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/editors/LexicalTableEditor2.java
===================================================================
--- tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/editors/LexicalTableEditor2.java	(revision 541)
+++ tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/editors/LexicalTableEditor2.java	(revision 542)
@@ -508,7 +508,7 @@
 	}
 	
 	@Override
-	public void refresh()	{
+	public void refresh(boolean update)	{
 		this.refreshTable();
 		this.viewer.getTable().deselectAll();
 		this.refreshInfos();
@@ -715,17 +715,6 @@
 	}
 
 	/**
-	 * Checks if is dirty.
-	 *
-	 * @return true, if is dirty
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return false;
-	}
-
-	/**
 	 * Checks if is save as allowed.
 	 *
 	 * @return true, if is save as allowed
Index: tmp/org.txm.internalview.rcp/src/org/txm/internal/rcp/editors/InternalViewEditor.java
===================================================================
--- tmp/org.txm.internalview.rcp/src/org/txm/internal/rcp/editors/InternalViewEditor.java	(revision 541)
+++ tmp/org.txm.internalview.rcp/src/org/txm/internal/rcp/editors/InternalViewEditor.java	(revision 542)
@@ -97,14 +97,6 @@
 	}
 
 	/* (non-Javadoc)
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return internalView.isDirty();
-	}
-
-	/* (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
 	 */
 	@Override
Index: tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/ConcordanceAnnotationExtension.java
===================================================================
--- tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/ConcordanceAnnotationExtension.java	(revision 541)
+++ tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/ConcordanceAnnotationExtension.java	(revision 542)
@@ -194,7 +194,7 @@
 							if (type != null) {
 								annotations.setViewAnnotation(type);
 								annotations.setAnnotationOverlap(true);
-								editor.fillDisplayArea(editor.getTopLine(), editor.getBottomLine()+1);
+								editor.fillDisplayArea();
 							}
 						}
 
@@ -401,7 +401,7 @@
 					if (concordance != null) {
 						annotations.setViewAnnotation(type);
 						annotations.setAnnotationOverlap(true);
-						editor.fillDisplayArea(editor.getTopLine(), editor.getBottomLine()+1);
+						editor.fillDisplayArea();
 					}
 
 					updateAnnotationWidgetStates();
@@ -477,15 +477,15 @@
 								if (concordance != null) {
 									annotations.setViewAnnotation(type);
 									annotations.setAnnotationOverlap(true);
-									editor.fillDisplayArea(editor.getTopLine(), editor.getBottomLine()+1);
+									editor.fillDisplayArea();
 								}
 								annotationArea.layout(true);
-							}else {
-								if (typesList.size() > 1){
-									if (annotationTypesCombo != null) annotationTypesCombo.getCombo().select(typesList.size()-1);
-
+							} else {
+								if (typesList.size() > 1) {
+									if (annotationTypesCombo != null) {
+										annotationTypesCombo.getCombo().select(typesList.size()-1);
+									}
 								}
-
 							}
 							KRView.refresh();
 							updateAnnotationWidgetStates();
@@ -502,7 +502,9 @@
 		if (advanced_annotation_mode) {
 			Label valueLabel = new Label(annotationArea, SWT.NONE);
 			String valueLabelText = currentKnowledgeRepository.getString(editor.getLocale(), "ConcordancesEditor_80");
-			if (valueLabelText == null) valueLabelText= Messages.ConcordancesEditor_80;
+			if (valueLabelText == null) {
+				valueLabelText= Messages.ConcordancesEditor_80;
+			}
 			valueLabel.setText(valueLabelText);
 			valueLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
 		}
@@ -529,7 +531,7 @@
 			addTypedValueLink.setText("..."); //$NON-NLS-1$
 			if (advanced_annotation_mode.equals(RCPMessages.AnnotationPreferences_2)) {
 				addTypedValueLink.setToolTipText(Messages.ConcordancesEditor_79);
-			}else {
+			} else {
 				addTypedValueLink.setToolTipText(Messages.ConcordancesEditor_77);
 			}
 			addTypedValueLink.setEnabled(true);
@@ -550,7 +552,7 @@
 						String title = currentKnowledgeRepository.getString(editor.getLocale(), "ConcordancesEditor_100");
 						if (title == null) title = Messages.ConcordancesEditor_100;
 						dialog.setTitle(Messages.bind(title, type.getName()));//+"valeurs de "+type.getName());
-					}else {
+					} else {
 						dialog.setTitle(Messages.ConcordancesEditor_99);//+"valeurs de "+type.getName());
 					}
 					dialog.setContentProvider(new ArrayContentProvider());
@@ -650,11 +652,8 @@
 			public void widgetDefaultSelected(SelectionEvent e) { }
 		});
 
-
 		updateAnnotationWidgetStates();
 		
-		
-
 		parent.layout();
 	}
 
@@ -663,7 +662,9 @@
 		final IStructuredSelection lineSelection = (IStructuredSelection) selection;
 		List<Line> lines = lineSelection.toList();
 		ArrayList<Match> matches = new ArrayList<Match>();
-		for (Line l : lines) matches.add(l.getMatch());
+		for (Line l : lines) {
+			matches.add(l.getMatch());
+		}
 
 		affectMatchesToSelection(matches);
 	}
@@ -671,7 +672,9 @@
 	protected AnnotationType getSelectedAnnotationType() {
 		if (annotationTypesCombo != null) {
 			IStructuredSelection isel = (IStructuredSelection)annotationTypesCombo.getSelection();
-			if (isel.isEmpty()) return null;
+			if (isel.isEmpty()) {
+				return null;
+			}
 			return (AnnotationType) isel.getFirstElement();
 		} else { // simple mode
 			return tagAnnotationType;
@@ -737,9 +740,13 @@
 		}
 
 		if (advanced_annotation_mode.equals(RCPMessages.AnnotationPreferences_2)) {
-			if (infosAnnotTypeSelectedLink != null) infosAnnotTypeSelectedLink.setEnabled(getSelectedAnnotationType() != null);
+			if (infosAnnotTypeSelectedLink != null) {
+				infosAnnotTypeSelectedLink.setEnabled(getSelectedAnnotationType() != null);
+			}
 		}
-		if (addTypedValueLink != null) addTypedValueLink.setEnabled(getSelectedAnnotationType() != null);
+		if (addTypedValueLink != null) {
+			addTypedValueLink.setEnabled(getSelectedAnnotationType() != null);
+		}
 
 		if (concordance == null) {
 			affectAnnotationButton.setEnabled(false);
@@ -748,12 +755,18 @@
 	}
 
 	protected void deleteAnnotationValues(List<Match> matches, AnnotationType type, JobHandler job) {
-		if (concordance == null) return;
+		if (concordance == null) {
+			return;
+		}
+		
 		if (matches.size() == 0) {
 			System.out.println("No lines selected. Aborting."); //$NON-NLS-1$
 			return;
 		}
-		if (type == null) return;
+		
+		if (type == null) {
+			return;
+		}
 
 		if (concordance != null) {
 			try {
@@ -772,7 +785,7 @@
 			job.syncExec(new Runnable() {
 				@Override
 				public void run() {
-					editor.fillDisplayArea(editor.getTopLine(), editor.getBottomLine()+1);
+					editor.fillDisplayArea();
 					CorporaView.refreshObject(corpus);
 				}
 			});
@@ -894,7 +907,7 @@
 		job.syncExec(new Runnable() {
 			@Override
 			public void run() {
-				editor.fillDisplayArea(editor.getTopLine(), editor.getBottomLine()+1);
+				editor.fillDisplayArea();
 				CorporaView.refreshObject(corpus);
 			}
 		});
Index: tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesEditor.java
===================================================================
--- tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesEditor.java	(revision 541)
+++ tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesEditor.java	(revision 542)
@@ -498,14 +498,6 @@
 	}
 
 	/* (non-Javadoc)
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return false;
-	}
-
-	/* (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
 	 */
 	@Override
